
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Attendance_recordsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const attendance_records = await db.attendance_records.create(
            {
                id: data.id || undefined,
        
        status: data.status
        ||
        null
            ,
            
        remarks: data.remarks
        ||
        null
            ,
            
        checked_at: data.checked_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await attendance_records.setAttendance_session( data.attendance_session || null, {
            transaction,
        });
        
        await attendance_records.setStudent( data.student || null, {
            transaction,
        });
        
        await attendance_records.setChecked_by( data.checked_by || null, {
            transaction,
        });
        
        await attendance_records.setSchools( data.schools || null, {
            transaction,
        });
        

        

        

        return attendance_records;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const attendance_recordsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                status: item.status
            ||
            null
            ,
            
                remarks: item.remarks
            ||
            null
            ,
            
                checked_at: item.checked_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const attendance_records = await db.attendance_records.bulkCreate(attendance_recordsData, { transaction });

        // For each item created, replace relation files
        

        return attendance_records;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const attendance_records = await db.attendance_records.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.remarks !== undefined) updatePayload.remarks = data.remarks;
        
        
        if (data.checked_at !== undefined) updatePayload.checked_at = data.checked_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await attendance_records.update(updatePayload, {transaction});

        
        
        if (data.attendance_session !== undefined) {
            await attendance_records.setAttendance_session(
              
              data.attendance_session,
              
              { transaction }
            );
        }
        
        if (data.student !== undefined) {
            await attendance_records.setStudent(
              
              data.student,
              
              { transaction }
            );
        }
        
        if (data.checked_by !== undefined) {
            await attendance_records.setChecked_by(
              
              data.checked_by,
              
              { transaction }
            );
        }
        
        if (data.schools !== undefined) {
            await attendance_records.setSchools(
              
              data.schools,
              
              { transaction }
            );
        }
        

        
        

        

        return attendance_records;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const attendance_records = await db.attendance_records.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of attendance_records) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of attendance_records) {
                await record.destroy({transaction});
            }
        });


        return attendance_records;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const attendance_records = await db.attendance_records.findByPk(id, options);

        await attendance_records.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await attendance_records.destroy({
            transaction
        });

        return attendance_records;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const attendance_records = await db.attendance_records.findOne(
            { where },
            { transaction },
        );

        if (!attendance_records) {
            return attendance_records;
        }

        const output = attendance_records.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.attendance_session = await attendance_records.getAttendance_session({
            transaction
        });
        
        
        output.student = await attendance_records.getStudent({
            transaction
        });
        
        
        output.checked_by = await attendance_records.getChecked_by({
            transaction
        });
        
        
        output.schools = await attendance_records.getSchools({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userSchools = (user && user.schools?.id) || null;
        

        
        if (userSchools) {
            if (options?.currentUser?.schoolsId) {
                where.schoolsId = options.currentUser.schoolsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.attendance_sessions,
        as: 'attendance_session',
        
        where: filter.attendance_session ? {
          [Op.or]: [
            { id: { [Op.in]: filter.attendance_session.split('|').map(term => Utils.uuid(term)) } },
            {
              notes: {
                [Op.or]: filter.attendance_session.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.students,
        as: 'student',
        
        where: filter.student ? {
          [Op.or]: [
            { id: { [Op.in]: filter.student.split('|').map(term => Utils.uuid(term)) } },
            {
              nis: {
                [Op.or]: filter.student.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'checked_by',
        
        where: filter.checked_by ? {
          [Op.or]: [
            { id: { [Op.in]: filter.checked_by.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.checked_by.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.schools,
        as: 'schools',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.remarks) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'attendance_records',
                        'remarks',
                        filter.remarks,
                    ),
                };
            }
            

            
            

            
            if (filter.checked_atRange) {
                const [start, end] = filter.checked_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    checked_at: {
                    ...where.checked_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    checked_at: {
                    ...where.checked_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      

      

      
      if (filter.schools) {
        const listItems = filter.schools.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          schoolsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.schoolsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.attendance_records.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'attendance_records',
                        'remarks',
                        query,
                    ),
                ],
            };
        }

        const records = await db.attendance_records.findAll({
            attributes: [ 'id', 'remarks' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['remarks', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.remarks,
        }));
    }

    
};

